/* Variable labels */
const char * VAR_LABEL1 = "a1";
const char * VAR_LABEL2 = "pressure";
const char * VAR_LABEL3 = "temperature";

/* Payload to be sent*/
char* payload = (char *) malloc(sizeof(char) * 150);

/* variable to save the sensor values */
char* A = (char *) malloc(sizeof(char) * 10);
char* P = (char *) malloc(sizeof(char) * 10);
char* T = (char *) malloc(sizeof(char) * 10);

/* Space to store values to send */
char str_sensor1[10];
char str_sensor2[10];
char str_sensor3[10];

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
}

void loop() {
  float sensor1 = analogRead(A0);
  float sensor2 = analogRead(A1);
  float sensor3 = analogRead(A2);
  
  /* 4 is mininum width, 2 is precision; float value is copied onto str_sensor*/
  dtostrf(sensor1, 4, 2, str_sensor1);
  dtostrf(sensor2, 4, 2, str_sensor2);  
  dtostrf(sensor3, 4, 2, str_sensor3);  

  /* save sensor values in variables*/ 
  sprintf(A, "%s", str_sensor1);
  sprintf(P, "%s", str_sensor2);
  sprintf(T, "%s", str_sensor3);

  /* Build payload */
  sprintf(payload, "{\"");
  sprintf(payload, "%s%s\":%s", payload, VAR_LABEL1, A);
  sprintf(payload, "%s,\"%s\":%s", payload, VAR_LABEL2, P);
  sprintf(payload, "%s,\"%s\":%s", payload, VAR_LABEL3, T);
  sprintf(payload, "%s}", payload);
  
  Serial.println(payload);
  /* free memory*/
  free(payload);

  delay(1000);
}
